// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// bot2.cpp (bothasar_t)
// the mirror bot.
// 12.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/wait.h>

#define DOWNLOAD_MSTD 1
#define NP_PREP_MSTD 2
#define LATEST_MSTD 3
#define STOP_MSTD 4

#define LINE_LIMIT 16000

###USERAGENT2

###ICT_ADDRESS
###OTT_ADDRESS
###FORA_ADDRESS

###LAST_PATH
###LOG_PATH
###NP_PATH
###NP_PATH_1
###NP_PATH_2
###NP_PATH_3
###STOP_PATH
###LIST_PATH
###SIG_PATH
###INF_PATH
###UP_PATH
###IND_PATH
###TOP_PATH
###END_PATH
###AV_PATH
###ATT_PATH
###IMG_PATH
###LAST_PAGE

###WGET_PATH
###MAWK_PATH
###RM_PATH
###AWK_LATEST
###AWK_LIST
###AWK_BOT2
###AWK_UPLOAD
###AWK_INDEX

FILE *cwfile;
FILE *stopfile;
bool logopen=false;
char stoppath[256];
char nppath [256];
char nppath1[256];
char nppath2[256];
char nppath3[256];
pid_t sub;
int r;

int main(int argc, char *argv[]);
int longline(const char *in,const char *out, unsigned long limit);
void end(int m);

int main(int argc, char *argv[])
{
	time_t t;
	
	int yarg;
	
	bool fi=false;
	bool fs=false;
	bool fm=false;
	bool fw=false;
	bool fv=false;
	bool fo=false;
	bool fp=false;
	bool recentbot=false;
	bool newlog=false;
	bool text=false;
	bool down=false;
	bool down2=false;
	bool down3=false;
	
	unsigned short botID=0;
	unsigned long start=1;
	unsigned long max=1;
	unsigned long posts=0xffffffff;
	unsigned long npwait=3;
	unsigned long await=15;
	unsigned long offset=1;
	unsigned long avoid=0;
	
	unsigned long i,np,last,last2;
	
	char argp1 [256];
	char argp2[256];
	char argp3[256];
	char argp4[256];
	char argp5[256];
	char argp6[256];
	char argp7[256];
	char temp   [256];
	char URL    [256];
	
	time(&t);
	opterr=0;
	
	while((yarg = getopt(argc,argv,"i:s:m:o:w:v:p:rntdab")) != -1)
	{
		switch(yarg)
		{
		case 'i':
			fi=true;
			if(optarg!=NULL)
				sscanf(optarg,"%hu",&botID);
			break;
		case 's':
			fs=true;
			if(optarg!=NULL)
				sscanf(optarg,"%lu",&start);
			break;
		case 'm':
			fm=true;
			if(optarg!=NULL)
				sscanf(optarg,"%lu",&max);
			break;
		case 'o':
			fo=true;
			if(optarg!=NULL)
				sscanf(optarg,"%lu",&offset);
			break;
		case 'w':
			fw=true;
			if(optarg!=NULL)
				sscanf(optarg,"%lu",&npwait);
			break;
		case 'v':
			fv=true;
			if(optarg!=NULL)
				sscanf(optarg,"%lu",&await);
			break;
		case 'p':
			fp=true;
			if(optarg!=NULL)
				sscanf(optarg,"%lu",&avoid);
			break;
		case 'r':
			recentbot=true;
			break;
		case 'n':
			newlog=true;
			break;
		case 't':
			text=true;
			break;
		case 'd':
			down=true;
			break;
		case 'a':
			down2=true;
			break;
		case 'b':
			down3=true;
			break;
		default:
			
			break;
		}
	}
	if(!fi)
		botID=0;
	if(!fo)
		offset=1;
	if(!fs)
	{
		sprintf(argp1,"%s%hu",LAST_PATH,botID);
		if((cwfile=fopen(argp1,"rt"))!=NULL)
		{
			fgets(temp,255,cwfile);
			sscanf(temp,"%lu",&start);
			fclose(cwfile);
			start=((start>offset)?(start+1-offset):1);
		}
		else
			start=1;
	}
	if(!fm)
		max=1;
	if(!fw)
		npwait=3;
	if(!fv)
		await=15;
	if(!fp)
		avoid=0;
	if(!text)
	{
		sprintf(argp1,"%s%hu",LOG_PATH,botID);
		if(freopen(argp1,newlog?"wt":"at",stdout)!=NULL)
			logopen=true;
	}
	setvbuf(stdout, NULL, _IONBF, 0);
	dup2(fileno(stdout),fileno(stderr));
	
	printf("\n%s",ctime(&t));
	printf("ID=%hu, offset=%lu, start=%lu, max=%lu, NP wait=%lus, A wait=%lus, present=%s -%lu, save_avatars=%s, save_attachments=%s, save_otherimg=%s",botID,offset,start,max,npwait,await,(recentbot?"YES":"NO"),avoid,(down?"YES":"NO"),(down2?"YES":"NO"),(down3?"YES":"NO"));
	
	
	sprintf(nppath ,"%s%hu",NP_PATH  ,botID);
	sprintf(nppath1,"%s%hu",NP_PATH_1,botID);
	sprintf(nppath2,"%s%hu",NP_PATH_2,botID);
	sprintf(nppath3,"%s%hu",NP_PATH_3,botID);
	sprintf(stoppath,"%s%hu",STOP_PATH,botID);
	
	stopfile=fopen(stoppath,"wt");
	if (stopfile==NULL)
		end(STOP_MSTD);
	if (lockf(fileno(stopfile),F_TLOCK,0)!=0)
		end(STOP_MSTD);	
	fprintf(stopfile,"%hu.FULL STOPFULL STOP\n",botID);
	
	for(i=0,last2=0xffffffff,np=start;(i<max)&&(np<=last2);++i,++np)
	{
		if(i!=0)
			sleep(npwait);
		
		printf("\n%lu: np%lu",i,np);
		sprintf(URL,"%s%lu",OTT_ADDRESS,(np-1)*40);
		
		// download the newpage
		printf(" download");
		sub=fork();
		if(!sub)
		{
			r=execl(WGET_PATH,WGET_PATH, "-q","-t", "3","-U", USERAGENT, "-O", nppath1,URL, (char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
		{ 
			printf(" %d ",r);
			end(DOWNLOAD_MSTD);
		}
		printf(" OK, prepare");
		
		// break long posts so that mawk doesn't fail
		r=longline(nppath1,nppath,LINE_LIMIT);
		if(r)
			end(NP_PREP_MSTD);
		printf(".");
		
		// what's the last page and how many posts are there?
		sprintf(argp1,"outfile=%s",nppath3);
		sub=fork();
		if(!sub)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_LATEST,"-v",argp1,nppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			end(LATEST_MSTD);
		printf(".");
		
		if((cwfile=fopen(nppath3,"rt"))!=NULL)
		{
			fscanf(cwfile,"%lu",&last);
			fscanf(cwfile,"%lu",&posts);
			fclose(cwfile);
		}
		else
			end(LATEST_MSTD);
		last2=(last>avoid)?(last-avoid):0;
		printf(".");
		if(np>last2)
		{
			printf("break(%lu)",last2);
			continue;
		}
		
		// List of posts
		// Yes, this could be done in the next script (It ewen was) but it has to be done BEFORE it.
		sprintf(argp1,"outfile=%s%lu",LIST_PATH,np);
		sub=fork();
		if(!sub)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_LIST,"-v",argp1,nppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			end(NP_PREP_MSTD);
		printf(".");
		
		// relink, convert, download things
		sprintf(argp1,"outfile=%s",nppath1);
		sprintf(argp2,"tempfile=%s",nppath2);
		sprintf(argp5,"imagepath=%s",IMG_PATH);
		sprintf(argp3,"avatarpath=%s",AV_PATH);
		sprintf(argp4,"attachmentpath=%s",ATT_PATH);
		sprintf(argp6,"wait=%lu",await);
		sprintf(argp7,"tempfile2=%s",nppath3);
		sub=fork();
		if(!sub)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_BOT2,"-v",argp1,"-v",argp2,"-v",argp3,"-v",argp4,"-v",argp5,"-v",argp6,"-v",argp7,"-v",(down?"download=YES":"download=NO"),"-v",(down2?"download2=YES":"download3=NO"),"-v",(down3?"download3=YES":"download3=NO"),nppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			end(NP_PREP_MSTD);
		printf(".OK, upload");
		
		// upload the newpage
		sprintf(argp1 ,"outfile=%s%lu",UP_PATH,np);
		sprintf(argp2,"sig=%s",SIG_PATH);
		sprintf(argp3,"otterinf=%s",INF_PATH);
		
		sub=fork();
		if(!sub)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_UPLOAD,"-v",argp1,"-v",argp2,"-v",argp3,nppath1,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			end(NP_PREP_MSTD);
		printf(" OK.");
		
		if((np==last2)&&(!recentbot))
			np=0L;
		
		sprintf(argp1,"%s%hu",LAST_PATH,botID);
		if((cwfile=fopen(argp1,"wt"))!=NULL)
		{
			fprintf(cwfile,"%lu\n",np);
			fclose(cwfile);
		}
		else
			end(LATEST_MSTD);
	}
	
	cwfile=fopen(LAST_PAGE,"wt");
	if(cwfile==NULL)
		end(LATEST_MSTD);
	fprintf(cwfile,"%lu\n",last);
	fprintf(cwfile,"%lu\n",posts);
	fclose(cwfile);
	
	if(recentbot)
	{
		// download index
		printf("\nindex download");
		sub=fork();
		if(!sub)
		{
			r=execl(WGET_PATH,WGET_PATH, "-q","-t", "3","-U", USERAGENT, "-O", nppath,ICT_ADDRESS, (char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		
		printf(" OK, prepare");
		// cut out only what's needed
		sprintf(argp1,"outfile=%s",nppath3);
		sub=fork();
		if(!sub)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_INDEX,"-v",argp1,nppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			end(NP_PREP_MSTD);
		printf(".");
		
		// relink
		sprintf(argp1,"outfile=%s",IND_PATH);
		sprintf(argp2,"tempfile=%s",nppath2);
		sprintf(argp3,"avatarpath=%s",AV_PATH);
		sprintf(argp5,"imagepath=%s",IMG_PATH);
		sprintf(argp4,"attachmentpath=%s",ATT_PATH);
		sprintf(argp6,"wait=%lu",await);
		sprintf(argp7,"tempfile2=%s",nppath1);
		sub=fork();
		if(!sub)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_BOT2,"-v",argp1,"-v",argp2,"-v",argp3,"-v",argp4,"-v",argp5,"-v",argp6,"-v",argp7,"-v","download=NO","-v","download2=NO","-v","download3=NO",nppath3,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			end(NP_PREP_MSTD);
		printf(".OK");
		
	}
	
	end(0);
}

//This function wouldn't be here if itt weren't for this post: http://forums.xkcd.com/viewtopic.php?p=3619766#p3619766
int longline(const char *in,const char *out, unsigned long limit)
{
	FILE *infile;
	FILE *outfile;
	bool tag;
	unsigned long counter=0;
	char ch;
	
	outfile=fopen(out,"wt");
	if(outfile==NULL)
		return 1;
	infile=fopen(in,"rt");
	if(infile==NULL)
	{
		fclose(outfile);
		return 1;
	}
	
	while(!feof(infile))
	{
		ch=(char)(fgetc(infile));
		fputc(ch,outfile);
		++counter;
		switch(ch)
		{
		case '<':
			tag=true;
			break;
		case '>':
			tag=false;
			if(counter>=limit)
			{
				fputc('\n',outfile);
				counter=0;
			}
			break;
		case ' ':
			if((!tag) && (counter>= limit))
			if(counter>=limit)
			{
				fputc('\n',outfile);
				counter=0;
			}
			break;
		case '\r':
		case '\n':
			counter=0;
			break;
		default:
			break;
		}
		
	}
	return 0;
}

void end(int m)
{
	switch(m)
	{
	case STOP_MSTD:
		printf("\nFULL STOPFULL STOP\n");
		break;
	case DOWNLOAD_MSTD:
		printf("\ndownload fail.\n");
		break;
	case NP_PREP_MSTD:
		printf("\nnewpage prepare fail.\n");
		break;
	case LATEST_MSTD:
		printf("\nnewestpage fail.\n");
		break;
	case 0:
		printf("\nOK\n");
		break;
	default:
		printf("\nCh*rping m*stard!\n");
	}
	if(logopen)
		fclose(stdout);
	if(m != STOP_MSTD)
	{
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",nppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",nppath1,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",nppath2,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",nppath3,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		
		
		lockf(fileno(stopfile),F_ULOCK,0);
		fclose(stopfile);
		
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",stoppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	exit(m);
}